## pqconnect 1.2.1

=== Makefile ===
USER:=pqconnect
GROUP:=pqconnect

VENV := venv
PYTHON := $(VENV)/bin/python3
PIPFLAGS := $(shell python3 scripts/external.py)

default: build

.PHONY: test clean

venv/bin/activate: pyproject.toml
	python3 -m venv $(VENV)
	$(PYTHON) -m pip install .[dev]

setup: venv/bin/activate

format: venv/bin/activate
	-$(PYTHON) -m isort src
	$(PYTHON) -m black src

lint:  venv/bin/activate
	-$(PYTHON) -m pyflakes src
	-$(PYTHON) -m pylint src
	-$(PYTHON) -m flake8 src
	-$(PYTHON) -m ruff src
	$(PYTHON) -m tryceratops src

type: venv/bin/activate
	-$(PYTHON) -m mypy src
	-$(PYTHON) -m pyright src
	[ -e .pyre_configuration ] || echo "src" | $(VENV)/bin/pyre init
	$(VENV)/bin/pyre check

coverage: venv/bin/activate
	sudo $(PYTHON) -m coverage report -m

dead: venv/bin/activate
	-$(PYTHON) -m vulture src

build-deps:
	scripts/download-build-install-deps

test: venv/bin/activate build-deps
	sudo $(PYTHON) -m coverage run -m unittest discover -v

test_%.py: venv/bin/activate build-deps
	sudo $(PYTHON) -m coverage run -m unittest test/$@

build: build-deps
	python3 -m build
	ls -alh dist/pqconnect*

audit-and-build: venv/bin/activate format lint type dead test build

install-user-and-group:
	-getent passwd ${USER} $2>/dev/null || sudo useradd -g ${GROUP} -r -m -s /bin/false ${USER}
	-getent group ${GROUP} $2>/dev/null || sudo groupadd -r ${GROUP}

install: build install-user-and-group
	-sudo pip install $(PIPFLAGS) dist/pqconnect-0.0.1-py3-none-any.whl

install-systemd-unitfiles:
	sudo cp misc/pqconnect-client.service /etc/systemd/system/
	sudo chmod 644 /etc/systemd/system/pqconnect-client.service
	sudo systemctl daemon-reload

clean:
	rm -rf dist downloads venv .pyre .pyre_configuration .coverage .ruff_cache .mypy_cache

uninstall: clean
	-sudo pip uninstall $(PIPFLAGS) pqconnect

test-run:
	@echo "Start pqconnect in another terminal and press [Enter]:"
	@bash -c read -n1
	curl -L www.pqconnect.net/test.html

=== debian/changelog ===
pqconnect (1.2.1-5) unstable; urgency=medium

  * pqconnect-server-keyserver update test:
    - test the keyserver by downloading the entire public-key and compare it
      with the content on the filesystem
    - add isolation-machine, allow-stderr, skippable
    - load `tun` kernel module, the test needs `/dev/net/tun`
    - re-enable test in salsa-ci.yml, anyway, the test is still skipped thanks
      to the "isolation machine"

 -- Jan Mojžíš <janmojzis@debian.org>  Sat, 22 Mar 2025 11:20:37 +0100

pqconnect (1.2.1-4) unstable; urgency=medium

  * d/control: add exact dependency (= ${binary:Version}) between packages
    python3-pqconnect / pqconnect / pqconnect-server
  * d/p/0005-handle-unpack-exception-in-keyserver.patch add, handle 'Unpack
    Exception' in keyserver
  * d/t/pqconnect-server-keyserver add
  * d/salsa-ci.yml: disable pqconnect-server-keyserver autopkgtest

 -- Jan Mojžíš <janmojzis@debian.org>  Sat, 22 Mar 2025 00:42:11 +0100

pqconnect (1.2.1-3) unstable; urgency=medium

  * d/pqconnect-server.postinst: generate initial server config
    and generate server keys
  * d/pqconnect-server.postrm: when purging a package, remove the
    /etc/pqconnect directory along with the configuration and encryption keys
  * d/pqconnect-server.service: use server options pqcport, keyport, host
    from configuration directory /etc/pqconnect/config
  * d/python3-pqconnect.triggers: add 'activate-await ldconfig' to refresh
    ldconfig cache. This ensures that the ldconfig cache used by
    ctypes.util.find_library() is updated before pqconnect start.

 -- Jan Mojžíš <janmojzis@debian.org>  Sun, 02 Mar 2025 21:58:12 +0100

pqconnect (1.2.1-2) unstable; urgency=medium

  [ Jan Mojžíš ]
  * d/salsa-ci.yml re-enable i386
  * d/p/debian/patches/0004-test-test_server.py-fix-alarms.patch add

 -- Simon Josefsson <simon@josefsson.org>  Tue, 11 Feb 2025 19:17:03 +0100

pqconnect (1.2.1-1) unstable; urgency=medium

  * Initial release. (Closes: #1091490)

 -- Simon Josefsson <simon@josefsson.org>  Fri, 27 Dec 2024 18:41:20 +0100

=== debian/control ===
Source: pqconnect
Maintainer: Debian Python Team <team+python@tracker.debian.org>
Uploaders:
 Simon Josefsson <simon@josefsson.org>,
 Jan Mojžíš <janmojzis@debian.org>,
Priority: optional
Standards-Version: 4.7.0
Section: python
Homepage: https://www.pqconnect.net/
Build-Depends:
 debhelper-compat (= 13),
 dh-sequence-python3,
 flit,
 help2man <!nodoc>,
 lib25519-1,
 libmceliece1,
 pybuild-plugin-pyproject,
 python3-all,
 python3-click,
 python3-dnspython,
 python3-lib25519,
 python3-mceliece,
 python3-netfilterqueue,
 python3-nftables,
 python3-ntruprime,
 python3-pyroute2,
 python3-pysodium,
 python3-pytest <!nocheck>,
 python3-scapy,
 python3-securestring,
 python3-setuptools,
Vcs-Git: https://salsa.debian.org/python-team/packages/pqconnect.git
Vcs-Browser: https://salsa.debian.org/python-team/packages/pqconnect
Rules-Requires-Root: no

Package: python3-pqconnect
Architecture: all
Depends:
 ${misc:Depends},
 ${python3:Depends},
Description: Post-Quantum Internet security layer (Python library)
 PQConnect is a new easy-to-install layer of Internet security.
 PQConnect lets you take action right now on your computer to address
 the threat of quantum attacks, without waiting for upgrades in the
 applications that you are using.
 .
 PQConnect automatically applies post-quantum cryptography from end to
 end between computers running PQConnect.  PQConnect adds
 cryptographic protection to unencrypted applications, works in
 concert with existing pre-quantum applications to add post-quantum
 protection, and adds a second application-independent layer of
 defense to any applications that have begun to incorporate
 application-specific post-quantum protection.
 .
 This package contains the Python library.

Package: pqconnect
Section: net
Architecture: all
Depends:
 adduser,
 python3-pqconnect (= ${binary:Version}),
 ${misc:Depends},
 ${python3:Depends},
Description: Post-Quantum Internet security layer (command-line tool)
 PQConnect is a new easy-to-install layer of Internet security.
 PQConnect lets you take action right now on your computer to address
 the threat of quantum attacks, without waiting for upgrades in the
 applications that you are using.
 .
 PQConnect automatically applies post-quantum cryptography from end to
 end between computers running PQConnect.  PQConnect adds
 cryptographic protection to unencrypted applications, works in
 concert with existing pre-quantum applications to add post-quantum
 protection, and adds a second application-independent layer of
 defense to any applications that have begun to incorporate
 application-specific post-quantum protection.
 .
 This package contains the command-line tools.

Package: pqconnect-server
Section: net
Architecture: all
Depends:
 pqconnect (= ${binary:Version}),
 ${misc:Depends},
 ${python3:Depends},
Description: Post-Quantum Internet security layer (server service)
 PQConnect is a new easy-to-install layer of Internet security.
 PQConnect lets you take action right now on your computer to address
 the threat of quantum attacks, without waiting for upgrades in the
 applications that you are using.
 .
 PQConnect automatically applies post-quantum cryptography from end to
 end between computers running PQConnect.  PQConnect adds
 cryptographic protection to unencrypted applications, works in
 concert with existing pre-quantum applications to add post-quantum
 protection, and adds a second application-independent layer of
 defense to any applications that have begun to incorporate
 application-specific post-quantum protection.
 .
 This package contains the server service.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk # DEB_VERSION

export PYBUILD_TEST_ARGS= -v --full-trace -k 'not test_nftables_integration and not test_check_overlapping_addresses and not test_tun_listen and not test_click and not test_file_perms and not test_save_keys and not test_save_keys_create_dir and not test_save_keys_create_dir_decline and not test_static_keygen and not test_static_keygen_fail and not test_add_chain and not test_add_queue_rule and not test_add_table and not test_build and not test__get_cname and not test_dns_handle and not test_generate_prekeys and not test_get_addrs and not test_get_pk_hash and not test__resolve_keyserver_address and not test_get_ephemeral_key and not test_get_static_key and not test_handshake_cannot_replay and not test_keyserver and not test_click_invalid_directory and not test__generate_cookie and not test__is_in_subnet and not test__make_local_ipv4 and not test__process_cookie_from_queue and not test__process_handshake_from_queue and not test__pton and not test__queue_send_packet and not test__receive_from_queue and not test__send_from_queue and not test__update_incoming_pk_addrs and not test_add_peer and not test_get_ip_from_iface and not test_get_next_ip and not test_get_peer_by_pkh and not test_prune_connection and not test_queue_incoming and not test_remove_expired_peers and not test_remove_peer'

%:
	dh $@ --buildsystem=pybuild

B = $(CURDIR)/debian/tmp/usr/bin
M = $(CURDIR)/debian/tmp/usr/share/man/man1

execute_after_dh_auto_install:
ifeq (,$(filter nodoc,$(DEB_BUILD_PROFILES)))
	mkdir -pv $(M)
	for p in "" "-keygen" "-server" "-dns-query"; do \
		env PYTHONPATH=$(CURDIR)/src \
		help2man --no-info --version-string="$(DEB_VERSION)" \
			-Idebian/pqconnect$$p.h2m $(B)/pqconnect$$p \
			-o $(M)/pqconnect$$p.1; \
	done
endif

=== debian/tests/control ===
Tests:
 pqconnect-server-keyserver,
Depends:
 kmod,
 pqconnect-server,
 psmisc,
Restrictions:
 allow-stderr,
 isolation-machine,
 needs-root,
 skippable,

## pqconnect 1.2.2

=== Makefile ===
--- 
+++ 
@@ -10,8 +10,11 @@
 .PHONY: test clean
 
 venv/bin/activate: pyproject.toml
-	python3 -m venv $(VENV)
+	python3 -m venv --copies $(VENV)
 	$(PYTHON) -m pip install .[dev]
+	sudo setcap 'cap_sys_admin=ep cap_net_admin=ep cap_net_raw=ep' venv/bin/python
+	sudo setcap 'cap_sys_admin=ep cap_net_admin=ep cap_net_raw=ep' venv/bin/python3
+	sudo setcap 'cap_sys_admin=ep cap_net_admin=ep cap_net_raw=ep' venv/bin/python3.12
 
 setup: venv/bin/activate

=== debian/changelog ===
pqconnect (1.2.2-1) unstable; urgency=medium

  * New upstream version 1.2.2 (Closes: 1101037)
  * d/p: refresh patches and remove patches that are fixed upstream:
    - d/p/0005-handle-unpack-exception-in-keyserver.patch
    - d/p/0003-use-python-lib25519.patch
    - d/p/0004-test-test_server.py-fix-alarms.patch
  * d/rules: build doc for pqconnect-server-check and don't build for removed
    pqconnect-dns-query
  * d/control: bump Standards-Version: 4.7.2, no changes
  * d/gbp.conf: add dist = DEP14, add [pull] track-missing = True

 -- Jan Mojžíš <janmojzis@debian.org>  Thu, 27 Mar 2025 20:18:51 +0100

pqconnect (1.2.1-6) unstable; urgency=medium

  * d/t/client.sh add, new pqconnect client autopkgtest
  * d/t/keygen.sh add, new pqconnect-keygen autopkgtest
  * d/t/pqconnect-server-keyserver rename to d/t/server.sh and
    simplified functionality, only one test query is sent to the keyserver
    and only l0-hash is compared.

 -- Jan Mojžíš <janmojzis@debian.org>  Thu, 27 Mar 2025 11:38:18 +0100

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
  Simon Josefsson <simon@josefsson.org>,
  Jan Mojžíš <janmojzis@debian.org>,
 Priority: optional
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Section: python
 Homepage: https://www.pqconnect.net/
 Build-Depends:

=== debian/rules ===
--- 
+++ 
@@ -13,7 +13,7 @@
 execute_after_dh_auto_install:
 ifeq (,$(filter nodoc,$(DEB_BUILD_PROFILES)))
 	mkdir -pv $(M)
-	for p in "" "-keygen" "-server" "-dns-query"; do \
+	for p in "" "-keygen" "-server" "-server-check"; do \
 		env PYTHONPATH=$(CURDIR)/src \
 		help2man --no-info --version-string="$(DEB_VERSION)" \
 			-Idebian/pqconnect$$p.h2m $(B)/pqconnect$$p \

=== debian/tests/control ===
Tests:
 server.sh,
Depends:
 kmod,
 pqconnect-server,
 psmisc,
Restrictions:
 allow-stderr,
 isolation-machine,
 needs-root,
 skippable,

Tests:
 client.sh,
Depends:
 bind9-dnsutils,
 kmod,
 pqconnect,
 psmisc,
 python3-dnslib,
Restrictions:
 isolation-machine,
 needs-root,
 skippable,

Tests:
 keygen.sh,
Depends:
 pqconnect,
Restrictions:
 allow-stderr,

=== debian/watch ===
version=4
opts="\
pagemangle=s|@ANY_VERSION@|<a href=https://www.pqconnect.net/pqconnect-$1.tar.gz>|\
" \
https://www.pqconnect.net/pqconnect-latest-version.txt \
https://www.pqconnect.net/pqconnect-@ANY_VERSION@.tar.gz

## pqconnect 1.2.3

=== debian/changelog ===
pqconnect (1.2.3-1) unstable; urgency=medium

  * New upstream version 1.2.3
  * d/watch: rewrite to version 5
  * d/salsa-ci.yml: use SALSA_CI_ENABLE_LICENSERECON: 1
  * d/control: remove Rules-Requires-Root: no

 -- Jan Mojžíš <janmojzis@debian.org>  Sat, 03 Jan 2026 23:14:15 +0100

=== debian/control ===
--- 
+++ 
@@ -31,7 +31,6 @@
  python3-setuptools,
 Vcs-Git: https://salsa.debian.org/python-team/packages/pqconnect.git
 Vcs-Browser: https://salsa.debian.org/python-team/packages/pqconnect
-Rules-Requires-Root: no
 
 Package: python3-pqconnect
 Architecture: all

=== debian/watch ===
Version: 5
Source: https://www.pqconnect.net/pqconnect-latest-version.txt
Page-Mangle: s|@ANY_VERSION@|<a href=https://www.pqconnect.net/pqconnect-$1.tar.gz>|
Matching-Pattern: https://www.pqconnect.net/pqconnect-@ANY_VERSION@.tar.gz
